local DG = DoomGuy
DG.RespawnPickups = {}

function DG.AmmoPickupHook(special, toucher)
	if not special or not special.valid or not toucher or not toucher.valid return true end
	
	local player = toucher.player
	if not DG.PlayerIsDoomGuy(player) then return true end
	if not player.doom then return true end
	
	if DG.GivePlayerAmmo(player, special.info.ammotype, special.info.damage) then
		S_StartSound(player.realmo, sfx_itempi, nil)
		P_RemoveMobj(special)
		return true
	end
	return true
end

function DG.WeaponPickupHook(special, toucher)
	if not special or not special.valid or not toucher or not toucher.valid return true end
	
	local player = toucher.player
	if not DG.PlayerIsDoomGuy(player) then return true end
	if not player.doom then return true end
	
	local ammo_usage = DG.Weapons[special.info.damage][special.info.weapontype].ammo_usage
	local ammo_type = DG.Weapons[special.info.damage][special.info.weapontype].ammo_type
	local ammo_give = ammo_type and DG.Ammos[ammo_type].give_amount or 0
	if (special.flags2 & MF2_DONTRESPAWN) then
		local amount = (gametyperules & GTR_CAMPAIGN) and 2 or 5
		if DG.GivePlayerWeapon(player, special.info.damage, special.info.weapontype, special.info.mass) then
			player.doom.item_flash = $ + HUDFLASH_YELLOWADD
			S_StartSound(player.realmo, sfx_wpnup, nil)
			P_RemoveMobj(special)
			return true
		elseif (ammo_usage ~= nil) and DG.GivePlayerAmmo(player, ammo_type, ammo_give * amount) then
			player.doom.item_flash = $ + HUDFLASH_YELLOWADD
			S_StartSound(player.realmo, sfx_wpnup, nil)
			P_RemoveMobj(special)
			return true
		end
	end
	
	if DG.GivePlayerWeapon(player, special.info.damage, special.info.weapontype, special.info.mass) then
		player.doom.item_flash = $ + HUDFLASH_YELLOWADD
		S_StartSound(player.realmo, sfx_wpnup, nil)
		if not (netgame or multiplayer) or (special.flags2 & MF2_DONTRESPAWN) then
			P_RemoveMobj(special)
		end
		return true
	end
	return true
end

function DG.SpecialPickupHook(special, toucher)
	if not special or not special.valid or not toucher or not toucher.valid return true end
	
	local player = toucher.player
	if not DG.PlayerIsDoomGuy(player) then return true end
	if not player.doom then return true end
	if not special.info.execute then return true end
	special.info.execute(player, special)
	return true
end