local DG = DoomGuy

freeslot("SPR_DAR0", "S_ITEM_SECURITY_ARMOR", "MT_ITEM_SECURITY_ARMOR")
states[S_ITEM_SECURITY_ARMOR] = {sprite = SPR_DAR0, frame = A|FF_ANIMATE, nextstate = S_ITEM_SECURITY_ARMOR, tics = -1, var1 = 1, var2 = 6}
mobjinfo[MT_ITEM_SECURITY_ARMOR] = {
	--$Name "Security Armor"
	--$Sprite ARM0A0
	--$Category "DOOM Items"
	doomednum = 4010,
	spawnstate = S_ITEM_SECURITY_ARMOR,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_SECURITY_ARMOR].execute = function(player, mobj)
	if (player.doom.armor >= player.doom.armor_max) then return end
	
	player.doom.armor = player.doom.armor_max
	player.doom.armor_efficiency = 33 * FU
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempi, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_SECURITY_ARMOR)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_SECURITY_ARMOR)

freeslot("SPR_DAR1", "S_ITEM_COMBAT_ARMOR", "MT_ITEM_COMBAT_ARMOR")
states[S_ITEM_COMBAT_ARMOR] = {sprite = SPR_DAR1, frame = A|FF_ANIMATE, nextstate = S_ITEM_COMBAT_ARMOR, tics = -1, var1 = 1, var2 = 6}
mobjinfo[MT_ITEM_COMBAT_ARMOR] = {
	--$Name "Combat Armor"
	--$Sprite ARM1A0
	--$Category "DOOM Items"
	doomednum = 4011,
	spawnstate = S_ITEM_COMBAT_ARMOR,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_COMBAT_ARMOR].execute = function(player, mobj)
	if (player.doom.armor >= (player.doom.armor_max * 2)) then return end
	
	player.doom.armor = player.doom.armor_max * 2
	player.doom.armor_efficiency = 50 * FU
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempi, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_COMBAT_ARMOR)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_COMBAT_ARMOR)