local DG = DoomGuy

freeslot("SPR_DHBN", "S_ITEM_HEALTH", "MT_ITEM_HEALTH")
states[S_ITEM_HEALTH] = {sprite = SPR_DHBN, frame = A|FF_ANIMATE, nextstate = S_ITEM_HEALTH, tics = -1, var1 = 5, var2 = 4}
mobjinfo[MT_ITEM_HEALTH] = {
	--$Name "Health Bonus"
	--$Sprite HBN0A0
	--$Category "DOOM Items"
	doomednum = 4015,
	spawnstate = S_ITEM_HEALTH,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_HEALTH].execute = function(player, mobj)
	if (player.doom.health < (player.doom.health_max * 2)) then
		player.doom.health = min($ + FU, player.doom.health_max * 2)
	end
	
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempi, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_HEALTH)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_HEALTH)

freeslot("SPR_DABN", "S_ITEM_ARMOR", "MT_ITEM_ARMOR")
states[S_ITEM_ARMOR] = {sprite = SPR_DABN, frame = A|FF_ANIMATE, nextstate = S_ITEM_ARMOR, tics = -1, var1 = 5, var2 = 4}
mobjinfo[MT_ITEM_ARMOR] = {
	--$Name "Armor Bonus"
	--$Sprite ABN0A0
	--$Category "DOOM Items"
	doomednum = 4016,
	spawnstate = S_ITEM_ARMOR,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_ARMOR].execute = function(player, mobj)
	if (player.doom.armor < (player.doom.armor_max * 2)) then
		if not player.doom.armor_efficiency then
			player.doom.armor_efficiency = 33 * FU
		end
		player.doom.armor = min($ + FU, player.doom.armor_max * 2)
	end
	
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempi, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_ARMOR)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_ARMOR)