local DG = DoomGuy

freeslot("SPR_DSUL", "S_ITEM_SOUL", "MT_ITEM_SOUL")
states[S_ITEM_SOUL] = {sprite = SPR_DSUL, frame = A|FF_ANIMATE, nextstate = S_ITEM_SOUL, tics = -1, var1 = 3, var2 = 6}
mobjinfo[MT_ITEM_SOUL] = {
	--$Name "Soul Sphere"
	--$Sprite SOULA0
	--$Category "DOOM Items"
	doomednum = 4012,
	spawnstate = S_ITEM_SOUL,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_SOUL].execute = function(player, mobj)
	if (player.doom.health < (player.doom.health_max * 2)) then
		player.doom.health = min($ + (100 * FU), player.doom.health_max * 2)
	end
	
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempw, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_SOUL)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_SOUL)

freeslot("SPR_DMGA", "S_ITEM_MEGA", "MT_ITEM_MEGA")
states[S_ITEM_MEGA] = {sprite = SPR_DMGA, frame = A|FF_ANIMATE, nextstate = S_ITEM_MEGA, tics = -1, var1 = 3, var2 = 6}
mobjinfo[MT_ITEM_MEGA] = {
	--$Name "Mega Sphere"
	--$Sprite MEGAA0
	--$Category "DOOM Items"
	doomednum = 4013,
	spawnstate = S_ITEM_MEGA,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_MEGA].execute = function(player, mobj)
	if (player.doom.health < (player.doom.health_max * 2)) then
		player.doom.health = player.doom.health_max * 2
	end

	if (player.doom.armor < (player.doom.armor_max * 2)) then
		player.doom.armor = player.doom.armor_max * 2
		player.doom.armor_efficiency = 50 * FU
	end
	
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempw, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_MEGA)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_MEGA)

freeslot("SPR_DINV", "S_ITEM_INVULNERABILITY", "MT_ITEM_INVULNERABILITY")
states[S_ITEM_INVULNERABILITY] = {sprite = SPR_DINV, frame = A|FF_ANIMATE, nextstate = S_ITEM_INVULNERABILITY, tics = -1, var1 = 3, var2 = 6}
mobjinfo[MT_ITEM_INVULNERABILITY] = {
	--$Name "Invulnerability Sphere"
	--$Sprite INVUA0
	--$Category "DOOM Items"
	doomednum = 4014,
	spawnstate = S_ITEM_INVULNERABILITY,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_SPECIAL
}
mobjinfo[MT_ITEM_INVULNERABILITY].execute = function(player, mobj)
	player.powers[pw_invulnerability] = 30 * TR
	
	player.doom.item_flash = $ + HUDFLASH_YELLOWADD
	S_StartSound(player.realmo, sfx_itempw, nil)
	P_RemoveMobj(mobj)
end
addHook("MobjSpawn", function(mobj) mobj.spriteyscale = FU + (FU / 5) end, MT_ITEM_INVULNERABILITY)
addHook("TouchSpecial", DG.SpecialPickupHook, MT_ITEM_INVULNERABILITY)