local DG = DoomGuy

freeslot("SPR_DCHA", "SPR_DCHF")
local function Fire(player, weapon)
	if not DG.PlayerCanUseWeapon(player, player.doom.weapon, weapon) then
		player.doom.state = WEAPONSTATE_READY
		player.doom.state_index = 1
		if weapon and weapon.states[player.doom.state] then
			DG.ExecutePlayerWeaponState(player, weapon)
			player.doom.tick = weapon.states[player.doom.state][player.doom.state_index].tics
		end
		return
	end
	DG.ConsumePlayerAmmo(player, weapon)
	player.realmo.state = S_PLAY_DOOMFIRING_SHOOT
	
	local damage = 5 * (P_RandomFixed() % (3 + 1))
	local accurate = player.doom.refire and (6 * FU) or 0
	DG.FirePlayer(player, MT_DBULLET, 2048 * FU, damage, DAMAGETYPE_GUNSHOT, player.realmo.angle, player.aiming, accurate, 0, 0, 0)
	S_StartSound(player.realmo, sfx_pist, nil)
end

DG.AddWeapon(4, {
	["chaingun"] = {
		name = "Chaingun",
		flags = WEAPONFLAG_AUTOFIRE,
		ammo_type = "clip",
		ammo_usage = 1,
		states = {
			[WEAPONSTATE_READY] = {
				{sprite = SPR_DCHA, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_LOWER] = {
				{sprite = SPR_DCHA, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_RAISE] = {
				{sprite = SPR_DCHA, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_ATTACK] = {
				{sprite = SPR_DCHA, frame = A, fsprite = SPR_DCHF, fframe = A, tics = 4, flags = 0, func = Fire, param = {}},
				{sprite = SPR_DCHA, frame = B, fsprite = SPR_DCHF, fframe = B, tics = 4, flags = 0, func = Fire, param = {}}, -- Fire
				{sprite = SPR_DCHA, frame = B, fsprite = nil, fframe = nil, tics = 0, flags = 0, func = DG.PlayerRefire, param = {}} -- Refire
			}
		}
	}
})