local DG = DoomGuy

freeslot("SPR_DFIS")
freeslot("sfx_fistpu")
freeslot("SPR_DSAW", "SPR_DSAF")
freeslot("sfx_sawup", "sfx_sawidle", "sfx_sawful", "sfx_sawhit")
local chainsawSounds = {sfx_sawup, sfx_sawidl, sfx_sawful}
local function MakeChainsawSound(player, weapon, sound)
	for index = 1, #chainsawSounds, 1 do
		S_StopSoundByID(player.realmo, chainsawSounds[index])
	end
	S_StartSound(player.realmo, chainsawSounds[sound], nil)
end

local function Attack(player, weapon, mode)
	player.realmo.state = S_PLAY_DOOMFIRING_SHOOT

	local damage = (P_RandomFixed() % (10 + 1)) << 1
	if player.doom.powers[POWERS_BERSERK] then
		damage = $ * 10
	end
	
	if (mode == 1) then
		player.powers[pw_strong] = STR_WALL|STR_FLOOR|STR_CEILING
	elseif (mode == 2) then
		damage = 2 * (P_RandomFixed() % (10 + 1))
	end
	
	local attack = DG.FirePlayer(player, MT_DBULLET, 64 * FU, damage, DAMAGETYPE_MELEE, player.realmo.angle, player.aiming, 6 * FU, 0, 0, 0)
	attack.meleeattack = mode
	if (mode == 1) then
		attack.custompoof = S_POOF_EFFECT3
	end
	
	if (mode == 2) then
		MakeChainsawSound(player, weapon, 3)
	end
end

local function Reset(player, weapon)
	player.powers[pw_strong] = 0
end

DG.AddWeapon(1, {
	["chainsaw"] = {
		name = "Chainsaw",
		flags = WEAPONFLAG_AUTOFIRE,
		ammo_type = nil,
		ammo_usage = nil,
		states = {
			[WEAPONSTATE_READY] = {
				{sprite = SPR_DSAW, frame = A, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = MakeChainsawSound, param = {2}},
				{sprite = SPR_DSAW, frame = B, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = MakeChainsawSound, param = {2}}
			},
			
			[WEAPONSTATE_LOWER] = {
				{sprite = SPR_DSAW, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_RAISE] = {
				{sprite = SPR_DSAW, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = MakeChainsawSound, param = {1}}
			},
			
			[WEAPONSTATE_ATTACK] = {
				{sprite = SPR_DSAF, frame = A, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = Attack, param = {2}},
				{sprite = SPR_DSAF, frame = B, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = Attack, param = {2}},
				{sprite = SPR_DSAF, frame = B, fsprite = nil, fframe = nil, tics = 0, flags = 0, func = DG.PlayerRefire, param = {}}
			}
		}
	},
	
	["fist"] = {
		name = "Fist",
		flags = WEAPONFLAG_AUTOFIRE,
		ammo_type = nil,
		ammo_usage = nil,
		states = {
			[WEAPONSTATE_READY] = {
				{sprite = SPR_DFIS, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_LOWER] = {
				{sprite = SPR_DFIS, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_RAISE] = {
				{sprite = SPR_DFIS, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_ATTACK] = {
				{sprite = SPR_DFIS, frame = B, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = nil, param = nil},
				{sprite = SPR_DFIS, frame = C, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = Attack, param = {1}},
				{sprite = SPR_DFIS, frame = D, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = Reset, param = {}},
				{sprite = SPR_DFIS, frame = C, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = nil, param = nil},
				{sprite = SPR_DFIS, frame = B, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = DG.PlayerRefire, param = {}}
			}
		}
	}
})