local DG = DoomGuy

freeslot("SPR_DSHT", "SPR_DSHF")
freeslot("sfx_sht")

freeslot("SPR_DSSG", "SPR_DSSF")
freeslot("sfx_ssg", "sfx_ssgo", "sfx_ssgl", "sfx_ssgc")
local function Fire(player, weapon)
	DG.ConsumePlayerAmmo(player, weapon)
	player.realmo.state = S_PLAY_DOOMFIRING_SHOOT
	for i = 0, 7 do
		local damage = 5 * (P_RandomFixed() % (3 + 1))
		DG.FirePlayer(player, MT_DBULLET, 2048 * FU, damage, DAMAGETYPE_SHELLSHOT, player.realmo.angle, player.aiming, 6 * FU, 0, 0, 0)
	end
	S_StartSound(player.realmo, sfx_sht, nil)
end

local ssg_sounds = {sfx_ssgo, sfx_ssgl, sfx_ssgc}
local function MakeSSGSound(player, weapon, sound)
	S_StartSound(player.realmo, ssg_sounds[sound], nil)
end

local function CheckSSGAmmo(player, weapon)
	if DG.PlayerCanUseWeapon(player, player.doom.weapon, weapon) then return end
	player.doom.state = WEAPONSTATE_READY
	player.doom.state_index = 1
	player.doom.tick = 0
end

local function SSGFire(player, weapon)
	DG.ConsumePlayerAmmo(player, weapon)
	player.realmo.state = S_PLAY_DOOMFIRING_SHOOT
	for i = 0, 20 do
		local damage = 5 * (P_RandomFixed() % (3 + 1))
		DG.FirePlayer(player, MT_DBULLET, 2048 * FU, damage, DAMAGETYPE_SHELLSHOT, player.realmo.angle, player.aiming, 11 * FU, 7 * FU, 0, 0)
	end
	S_StartSound(player.realmo, sfx_ssg, nil)
end

DG.AddWeapon(3, {
	["supershotgun"] = {
		name = "Super Shotgun",
		flags = WEAPONFLAG_AUTOFIRE,
		ammo_type = "shell",
		ammo_usage = 2,
		states = {
			[WEAPONSTATE_READY] = {
				{sprite = SPR_DSSG, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_LOWER] = {
				{sprite = SPR_DSSG, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_RAISE] = {
				{sprite = SPR_DSSG, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_ATTACK] = {
				{sprite = SPR_DSSG, frame = A, fsprite = nil, fframe = nil, tics = 3, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSSG, frame = A, fsprite = SPR_DSSF, fframe = A, tics = 3, flags = 0, func = SSGFire, param = {}}, -- Fire
				{sprite = SPR_DSSG, frame = A, fsprite = SPR_DSSF, fframe = B, tics = 4, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSSG, frame = B, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSSG, frame = C, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = CheckSSGAmmo, param = {}},
				{sprite = SPR_DSSG, frame = D, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = MakeSSGSound, param = {1}},
				{sprite = SPR_DSSG, frame = E, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSSG, frame = F, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = MakeSSGSound, param = {2}},
				{sprite = SPR_DSSG, frame = G, fsprite = nil, fframe = nil, tics = 6, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSSG, frame = H, fsprite = nil, fframe = nil, tics = 6, flags = 0, func = MakeSSGSound, param = {3}},
				{sprite = SPR_DSSG, frame = A, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = DG.PlayerRefire, param = {}} -- Refire
			}
		}
	},
	["shotgun"] = {
		name = "Shotgun",
		flags = WEAPONFLAG_AUTOFIRE,
		ammo_type = "shell",
		ammo_usage = 1,
		states = {
			[WEAPONSTATE_READY] = {
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_LOWER] = {
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_RAISE] = {
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = -1, flags = 0, func = nil, param = nil}
			},
			
			[WEAPONSTATE_ATTACK] = {
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = 3, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = A, fsprite = SPR_DSHF, fframe = A, tics = 4, flags = 0, func = Fire, param = {}}, -- Fire
				{sprite = SPR_DSHT, frame = A, fsprite = SPR_DSHF, fframe = B, tics = 3, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = B, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = C, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = D, fsprite = nil, fframe = nil, tics = 4, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = C, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = B, fsprite = nil, fframe = nil, tics = 5, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = 3, flags = 0, func = nil, param = nil},
				{sprite = SPR_DSHT, frame = A, fsprite = nil, fframe = nil, tics = 7, flags = 0, func = DG.PlayerRefire, param = {}} -- Refire
			}
		}
	}
})