local DG = DoomGuy

freeslot("sfx_itempi", "sfx_itempw", "sfx_wpnup")
freeslot("sfx_gibb", "sfx_explo1", "sfx_firxpl", "sfx_rxplod")
freeslot("sfx_plpain", "sfx_pldead", "sfx_plsuff", "sfx_ploof")

freeslot("SPR2_FIRE", "SPR2_FIRR")
freeslot("S_PLAY_DOOMFIRING", "S_PLAY_DOOMFIRING_SHOOT")
states[S_PLAY_DOOMFIRING] = {sprite = SPR_PLAY, frame = SPR2_FIRE, nextstate = S_PLAY_STND, tics = 12, var1 = 0, var2 = 0}
states[S_PLAY_DOOMFIRING_SHOOT] = {sprite = SPR_PLAY, frame = SPR2_FIRR|FF_FULLBRIGHT, nextstate = S_PLAY_DOOMFIRING, tics = 6, var1 = 0, var2 = 0}

freeslot("SPR2_DIED", "SPR2_DIEX")
freeslot("SPR2_CORP", "SPR2_CORX")
freeslot("S_PLAY_DOOMDEAD", "S_PLAY_DOOMXDEAD")
freeslot("S_PLAY_DOOMCORPSE", "S_PLAY_DOOMXCORPSE")
freeslot("MT_DEADCORPSE")
mobjinfo[MT_DEADCORPSE] = {
	spawnstate = S_INVISIBLE,
	radius = 8 * FU,
	height = 16 * FU,
	speed = 0 * FU
}

states[S_PLAY_DOOMDEAD] = {sprite = SPR_PLAY, frame = SPR2_DIED|FF_ANIMATE, nextstate = S_PLAY_DOOMCORPSE, tics = 60, var1 = 6, var2 = 10}
states[S_PLAY_DOOMXDEAD] = {sprite = SPR_PLAY, frame = SPR2_DIEX|FF_ANIMATE, nextstate = S_PLAY_DOOMXCORPSE, tics = 70, var1 = 8, var2 = 6}
states[S_PLAY_DOOMCORPSE] = {sprite = SPR_PLAY, frame = SPR2_CORP, nextstate = S_PLAY_DOOMCORPSE, tics = -1, var1 = 0, var2 = 0}
states[S_PLAY_DOOMXCORPSE] = {sprite = SPR_PLAY, frame = SPR2_CORX, nextstate = S_PLAY_DOOMXCORPSE, tics = -1, var1 = 0, var2 = 0}

freeslot("MT_DFLASHHELPER")
mobjinfo[MT_DFLASHHELPER] = {
	spawnstate = S_INVISIBLE,
	radius = 64 * FU,
	height = FU,
	speed = 0 * FU
}

freeslot("SPR_DBLD")
freeslot("S_BLOOD_EFFECT1", "S_BLOOD_EFFECT2", "S_BLOOD_EFFECT3")
freeslot("MT_DBLOOD")
states[S_BLOOD_EFFECT1] = {sprite = SPR_DBLD, frame = C, nextstate = S_BLOOD_EFFECT2, tics = 8, var1 = 0, var2 = 0}
states[S_BLOOD_EFFECT2] = {sprite = SPR_DBLD, frame = B, nextstate = S_BLOOD_EFFECT3, tics = 8, var1 = 0, var2 = 0}
states[S_BLOOD_EFFECT3] = {sprite = SPR_DBLD, frame = A, nextstate = S_NULL, tics = 8, var1 = 0, var2 = 0}
mobjinfo[MT_DBLOOD] = {
	spawnstate = S_BLOOD_EFFECT1,
	radius = 20 * FRACUNIT,
	height = 16 * FRACUNIT,
	flags = MF_NOBLOCKMAP
}

freeslot("SPR_DPFF")
freeslot("S_POOF_EFFECT1", "S_POOF_EFFECT2", "S_POOF_EFFECT3", "S_POOF_EFFECT4")
freeslot("MT_DPOOF")
states[S_POOF_EFFECT1] = {sprite = SPR_DPFF, frame = A|FF_FULLBRIGHT, nextstate = S_POOF_EFFECT2, tics = 4, var1 = 0, var2 = 0}
states[S_POOF_EFFECT2] = {sprite = SPR_DPFF, frame = B, nextstate = S_POOF_EFFECT3, tics = 4, var1 = 0, var2 = 0}
states[S_POOF_EFFECT3] = {sprite = SPR_DPFF, frame = C, nextstate = S_POOF_EFFECT4, tics = 4, var1 = 0, var2 = 0}
states[S_POOF_EFFECT4] = {sprite = SPR_DPFF, frame = D, nextstate = S_NULL, tics = 4, var1 = 0, var2 = 0}
mobjinfo[MT_DPOOF] = {
	spawnstate = S_POOF_EFFECT1,
	radius = 4 * FU,
	height = 4 * FU,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

function A_DPoof(actor, var1, var2)
	if actor.nopoof then return end

	local mobj = P_SpawnMobjFromMobj(actor, 0, 0, 0, MT_DPOOF)
	if actor.custompoof then
		mobj.state = actor.custompoof
	end
	/*if actor.meleeattack and (actor.meleeattack == 1) then
		mobj.state = S_POOF_EFFECT3
	end*/
end

freeslot("S_DBULLETDEATH")
freeslot("MT_DBULLET")
states[S_DBULLETDEATH] = {sprite = SPR_NULL, frame = A, action = A_DPoof, nextstate = S_NULL, tics = 0, var1 = 0, var2 = 0}
mobjinfo[MT_DBULLET] = {
	spawnstate = S_INVISIBLE,
	deathstate = S_DBULLETDEATH,
	radius = 4 * FU,
	height = 4 * FU,
	speed = 4 * FU,
	flags = MF_MISSILE|MF_NOGRAVITY
}

local function RocketExplodeWalls(mobj)
	local oldx = mobj.x
	local oldy = mobj.y
	local oldz = mobj.z
	local maxdist = 128 * mobj.scale
	local oldheight = mobj.height
	mobj.height = 600 * mobj.scale
	
	local dists = 6
	local rots = 32
	local dnum = 0
	while (dnum < dists) do
		local dist = (maxdist / dists) * (dnum + 1)
		local rnum = 0
		while (rnum < rots) do
			local rot = FixedAngle(((360 * FU) / rots) * rnum)
			P_SetOrigin(mobj, oldx+FixedMul(cos(rot), dist), oldy + FixedMul(sin(rot), dist), oldz - (mobj.height / 2))
			
			for rover in mobj.subsector.sector.ffloors() -- Check for floors
				if (rover.flags & FF_EXISTS) and (rover.flags & FF_BUSTUP) then -- Needs to exist and breakable
					local oldflags = rover.flags
					rover.flags = $ & ~(FF_BLOCKPLAYER|FF_BLOCKOTHERS) -- Make it non solid so we can check if we're inside it!
					if P_InsideANonSolidFFloor(mobj, rover) -- Inside it?
						rover.flags = oldflags -- Restore its solidity!
						EV_CrumbleChain(mobj.subsector.sector, rover) -- Bust it!
						if (rover.master.flags & ML_EFFECT5) -- Run a linedef executor??
							P_LinedefExecute(P_AproxDistance(rover.master.dx, rover.master.dy) >> FRACBITS, mobj, mobj.subsector.sector)
						end
					else
						rover.flags = oldflags -- Restore its solidity!
					end
				end
			end
			rnum = $ + 1
		end
		dnum = $ + 1
	end
	P_SetOrigin(mobj, oldx, oldy, oldz)
	mobj.height = oldheight
end

local function LaunchObjectByExplosion(refmobj, foundmobj, radius)
	P_SetOrigin(foundmobj, foundmobj.x, foundmobj.y, foundmobj.z + FU) -- stupid fix
			
	local rocket_distance = R_PointToDist2(foundmobj.x, foundmobj.y, refmobj.x + refmobj.dmomx, refmobj.y + refmobj.dmomy)
	local rocket_hangle = R_PointToAngle2(foundmobj.x, foundmobj.y, refmobj.x + refmobj.dmomx, refmobj.y + refmobj.dmomy)
	local rocket_vangle = R_PointToAngle2(rocket_distance, foundmobj.z, 0, refmobj.z + refmobj.dmomz)
	
	P_InstaThrust(foundmobj, rocket_hangle, cos(rocket_vangle) * 30)
	foundmobj.momz = -sin(rocket_vangle) * 30
	if (foundmobj.eflags & MFE_UNDERWATER) then
		foundmobj.momx, foundmobj.momy, foundmobj.momy = (($1 * 3) / 5), (($2 * 3) / 5), (($3 * 3) / 5)
	end
	
	if foundmobj.player and foundmobj.player.valid then
		local taken = FixedInt(radius - rocket_distance) / 2
		local self = (refmobj.target ~= foundmobj) and refmobj.target or nil
		P_DamageMobj(foundmobj, refmobj, self, taken, DAMAGETYPE_EXPLOSION) -- works fine when the player is itself, but fails agains't other players
	end
end

function A_DExplode(actor, var1, var2)
	local radius = var1 * actor.scale
	actor.health = radius -- damn hack, see Player/damage.lua
	searchBlockmap("objects", function(refmobj, foundmobj)
		if not P_CheckSight(refmobj, foundmobj) then return end
		--if (abs(refmobj.z - foundmobj.z) > radius) then continue end
		
		if not (foundmobj.flags & MF_SHOOTABLE) then
			if (foundmobj.flags & MF_PUSHABLE) then
				LaunchObjectByExplosion(refmobj, foundmobj, radius)
			end
		
			if (foundmobj.type == MT_SPIKE) or (foundmobj.type == MT_WALLSPIKE) then
				if foundmobj.valid and foundmobj.health then
					P_KillMobj(foundmobj)
				end
			end
			return
		end
		
		if foundmobj.player and foundmobj.player.valid then
			LaunchObjectByExplosion(refmobj, foundmobj, radius)
			return
		end
		P_DamageMobj(foundmobj, refmobj, refmobj.target, 3, DAMAGETYPE_EXPLOSION)
	end, actor, actor.x - FixedMul(radius, FU / 2), actor.x + FixedMul(radius, FU / 2), actor.y - FixedMul(radius, FU / 2), actor.y + FixedMul(radius, FU / 2))
	RocketExplodeWalls(actor)
	
	S_StartSound(actor, sfx_explo1)
end

freeslot("SPR_DRTK", "SPR_DEXP")
freeslot("S_DEXPLODE1", "S_DEXPLODE2", "S_DEXPLODE3")
freeslot("S_DROCKET")
freeslot("MT_DROCKET")
states[S_DROCKET] = {sprite = SPR_DRTK, frame = A, tics = -1, var1 = 0, var2 = 0}
states[S_DEXPLODE1] = {sprite = SPR_DEXP, frame = A|FF_FULLBRIGHT, action = A_DExplode, nextstate = S_DEXPLODE2, tics = 8, var1 = 256, var2 = 0}
states[S_DEXPLODE2] = {sprite = SPR_DEXP, frame = B|FF_FULLBRIGHT, nextstate = S_DEXPLODE3, tics = 6, var1 = 0, var2 = 0}
states[S_DEXPLODE3] = {sprite = SPR_DEXP, frame = C|FF_FULLBRIGHT, nextstate = S_NULL, tics = 4, var1 = 0, var2 = 0}
mobjinfo[MT_DROCKET] = {
	spawnstate = S_DROCKET,
	deathstate = S_DEXPLODE1,
	radius = 11 * FU,
	height = 8 * FU,
	speed = 30 * FU,
	flags = MF_MISSILE|MF_NOGRAVITY
}

function A_DPlasmaExplode(actor, var1, var2)
	S_StartSound(actor, sfx_firxpl)
end

freeslot("SPR_DPLS", "SPR_DPEX")
freeslot("S_DPLASMA1", "S_DPLASMA2")
freeslot("S_DPLASMAEXPLODE1", "S_DPLASMAEXPLODE2", "S_DPLASMAEXPLODE3", "S_DPLASMAEXPLODE4", "S_DPLASMAEXPLODE5")
freeslot("MT_DPLASMA")
states[S_DPLASMA1] = {sprite = SPR_DPLS, frame = A|FF_FULLBRIGHT, nextstate = S_DPLASMA2, tics = 3, var1 = 0, var2 = 0}
states[S_DPLASMA2] = {sprite = SPR_DPLS, frame = B|FF_FULLBRIGHT, nextstate = S_DPLASMA1, tics = 3, var1 = 0, var2 = 0}

states[S_DPLASMAEXPLODE1] = {sprite = SPR_DPEX, frame = A|FF_FULLBRIGHT, action = A_DPlasmaExplode, nextstate = S_DPLASMAEXPLODE2, tics = 4, var1 = 0, var2 = 0}
states[S_DPLASMAEXPLODE2] = {sprite = SPR_DPEX, frame = B|FF_FULLBRIGHT, nextstate = S_DPLASMAEXPLODE3, tics = 4, var1 = 0, var2 = 0}
states[S_DPLASMAEXPLODE3] = {sprite = SPR_DPEX, frame = C|FF_FULLBRIGHT, nextstate = S_DPLASMAEXPLODE4, tics = 4, var1 = 0, var2 = 0}
states[S_DPLASMAEXPLODE4] = {sprite = SPR_DPEX, frame = D|FF_FULLBRIGHT, nextstate = S_DPLASMAEXPLODE5, tics = 4, var1 = 0, var2 = 0}
states[S_DPLASMAEXPLODE5] = {sprite = SPR_DPEX, frame = E|FF_FULLBRIGHT, nextstate = S_NULL, tics = 4, var1 = 0, var2 = 0}

mobjinfo[MT_DPLASMA] = {
	spawnstate = S_DPLASMA1,
	deathstate = S_DPLASMAEXPLODE1,
	radius = 13 * FU,
	height = 8 * FU,
	speed = 30 * FU,
	flags = MF_MISSILE|MF_NOGRAVITY
}

function A_DBFGExplosion(actor, var1, var2)
	S_StartSound(actor, sfx_rxplod)
end

function A_DBFGSpray(actor, var1, var2)
	local damage = 0
	for tracer_iteration = 0, 40, 1 do
		for damage_iteration = 0, 15, 1 do
			damage = $ + ((P_RandomFixed() & 7) + 1)
		end
		
		local hangle = (actor.hangle - ANGLE_90) + (ANGLE_90 / 2 + ANGLE_90 / 40 * tracer_iteration)
		local vangle = actor.vangle
		/*if actor.target and actor.target.valid and actor.target.player and actor.target.player.valid then
			local enemy = P_LookForEnemies(actor.target.player, false, true) -- time to suffer lol
			--print(enemy)
			if enemy and enemy.valid then
				local enemyAngle = R_PointToAngle2(actor.target.x, actor.target.y, enemy.x, enemy.y)
				local enemyXY = R_PointToDist2(actor.target.x, actor.target.y, enemy.x, enemy.y)
				local enemyZ = enemy.z - actor.target.z
				local enemyVertical = R_PointToAngle2(0, 0, enemyXY, enemyZ)
				
				local validH = (AngleFixed(hangle - enemyAngle) <= (5 * FU)) or (AngleFixed(hangle - enemyAngle) >= (355 * FU))
				local validV = (AngleFixed(vangle - enemyVertical) <= (56 * FU)) or (AngleFixed(vangle - enemyVertical) >= (304 * FU))
				print("tracer #" .. tracer_iteration .. ": checking angles")
				print("validH: " .. tostring(FixedInt(AngleFixed(hangle - enemyAngle))))
				print("validV: " .. tostring(FixedInt(AngleFixed(vangle - enemyVertical))))
				if validH and validV then
					vangle = enemyVertical
					print("tracer #" .. tracer_iteration .. ": found a enemy, trying to hit")
				end
			end
		end*/

		local tracer = DG.Fire(actor.target, MT_DBULLET, mobjinfo[MT_DBULLET].speed, 1024 * FU, damage, DAMAGETYPE_BFGTRACER, hangle, vangle, 0, 0, 0, 0, (32 * FU), 0, 0)
		tracer.nopoof = true
		tracer.bfgtracer = true
	end
end

freeslot("SPR_DBFH")
freeslot("S_DBFGHIT1", "S_DBFGHIT2", "S_DBFGHIT3", "S_DBFGHIT4")
freeslot("MT_DBFGHIT")
states[S_DBFGHIT1] = {sprite = SPR_DBFH, frame = A|FF_FULLBRIGHT, nextstate = S_DBFGHIT2, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGHIT2] = {sprite = SPR_DBFH, frame = B|FF_FULLBRIGHT, nextstate = S_DBFGHIT3, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGHIT3] = {sprite = SPR_DBFH, frame = C|FF_FULLBRIGHT, nextstate = S_DBFGHIT4, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGHIT4] = {sprite = SPR_DBFH, frame = D|FF_FULLBRIGHT, nextstate = S_NULL, tics = 8, var1 = 0, var2 = 0}

mobjinfo[MT_DBFGHIT] = {
	spawnstate = S_DBFGHIT1,
	radius = 4 * FU,
	height = 4 * FU,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

freeslot("SPR_DGBM", "SPR_DGBE")
freeslot("S_DBFGBALL1", "S_DBFGBALL2")
freeslot("S_DBFGBALLEXPLODE1", "S_DBFGBALLEXPLODE2", "S_DBFGBALLEXPLODE3", "S_DBFGBALLEXPLODE4", "S_DBFGBALLEXPLODE5", "S_DBFGBALLEXPLODE6")
freeslot("MT_DBFG")
states[S_DBFGBALL1] = {sprite = SPR_DGBM, frame = A|FF_FULLBRIGHT, nextstate = S_DBFGBALL2, tics = 4, var1 = 0, var2 = 0}
states[S_DBFGBALL2] = {sprite = SPR_DGBM, frame = B|FF_FULLBRIGHT, nextstate = S_DBFGBALL1, tics = 4, var1 = 0, var2 = 0}

states[S_DBFGBALLEXPLODE1] = {sprite = SPR_DGBE, frame = A|FF_FULLBRIGHT, action = A_DBFGExplosion, nextstate = S_DBFGBALLEXPLODE2, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGBALLEXPLODE2] = {sprite = SPR_DGBE, frame = B|FF_FULLBRIGHT, nextstate = S_DBFGBALLEXPLODE3, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGBALLEXPLODE3] = {sprite = SPR_DGBE, frame = C|FF_FULLBRIGHT, action = A_DBFGSpray, nextstate = S_DBFGBALLEXPLODE4, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGBALLEXPLODE4] = {sprite = SPR_DGBE, frame = D|FF_FULLBRIGHT, nextstate = S_DBFGBALLEXPLODE5, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGBALLEXPLODE5] = {sprite = SPR_DGBE, frame = E|FF_FULLBRIGHT, nextstate = S_DBFGBALLEXPLODE6, tics = 8, var1 = 0, var2 = 0}
states[S_DBFGBALLEXPLODE6] = {sprite = SPR_DGBE, frame = F|FF_FULLBRIGHT, nextstate = S_NULL, tics = 8, var1 = 0, var2 = 0}

mobjinfo[MT_DBFG] = {
	spawnstate = S_DBFGBALL1,
	deathstate = S_DBFGBALLEXPLODE1,
	radius = 13 * FU,
	height = 8 * FU,
	speed = 30 * FU,
	flags = MF_MISSILE|MF_NOGRAVITY
}

freeslot("sfx_telepo")
freeslot("SPR_DTEL")
freeslot("S_DTELEPORT")
freeslot("MT_DTELEPORT")
states[S_DTELEPORT] = {sprite = SPR_DTEL, frame = A|FF_FULLBRIGHT|FF_ANIMATE, nextstate = S_NULL, tics = 54, var1 = 9, var2 = 6}
mobjinfo[MT_DTELEPORT] = {
	spawnstate = S_DTELEPORT,
	radius = 4 * FU,
	height = 4 * FU,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
