local DG = DoomGuy

local WEAPONTOP = 0
local WEAPONBOTTOM = 128
local RAISESPEED = 6
local LOWERSPEED = 6

DG.OverrideHUDs = {"lives", "weaponrings"} -- "score", "time", "rings", "textspectator", "crosshair"
DG.CompatibleCharacters = {["doomguy"] = true}

function DG.PlayerIsDoomGuy(player)
	return DG.CompatibleCharacters[skins[player.skin].name] or nil
end

function DG.SetupPlayer(player)
	if not player.doom then
		player.doom = {}
	end

	player.doom.health = 100 * FU
	player.doom.health_max = 100 * FU
	
	player.doom.armor = 0
	player.doom.armor_max = 100 * FU
	player.doom.armor_efficiency = 0
	
	player.doom.oxygen = 100 * FU
	player.doom.oxygen_max = 100 * FU
	player.doom.oxygen_drainrate = (FU / 8)
	player.doom.oxygen_gainrate = (FU / 2)
	
	player.doom.pending_weapon = WEAPONSTATE_NONE
	player.doom.pending_weapon_slot = 0

	player.doom.weapon = WEAPONSTATE_NONE
	player.doom.weapon_slot = 0
	player.doom.weapon_slot_index = 0
	
	player.doom.state = WEAPONSTATE_CHANGE
	player.doom.state_index = 1
	player.doom.tick = 0
	player.doom.tick_speed = 1
	
	player.doom.weapon_sprites = {}
	for index = 0, 2, 1 do
		player.doom.weapon_sprites[index] = {sprite = SPR_NULL, frame = A}
	end
	
	player.doom.weapon_xoffset = 0
	player.doom.weapon_yoffset = WEAPONBOTTOM
	
	player.doom.firing = false
	player.doom.refire = 0
	
	player.doom.previous_buttons = 0
	player.doom.previous_momz = 0
	
	player.doom.crouching = false
	player.doom.sprinting = false
	player.doom.dead = false
	player.doom.gibbed = false
	
	player.doom.attacker = nil
	player.doom.attacker_time = 0
	player.doom.invulnerability_tick = 0
	player.doom.hurted_flash = 0
	player.doom.item_flash = 0
	player.doom.rings = 0
	
	if not player.doom.powers then
		player.doom.powers = {}
	end
	
	player.doom.ammo = {}
	player.doom.ammo_max = {}
	for index, ammo in pairs(DG.Ammos) do
		player.doom.ammo[index] = 0
		player.doom.ammo_max[index] = ammo.max_amount
	end
	player.doom.ammo["clip"] = 50
	
	player.doom.weapons = {}
	player.doom.weapons["fist"] = true
	player.doom.weapons["pistol"] = true
	player.doom.pending_weapon = "pistol"
	player.doom.pending_weapon_slot = 2
end